var mongoose = require("mongoose");
var MovieSchema = new mongoose.Schema({
    flash : String,
    poster : String,
    doctor : String,
    type : String,
    title : String,
    language : String,
    country : String,
    brief : String,
    meta:{
        createAt : {
            type : Date,
            default : Date.now()
        },
        updateAt : {
            type : Date,
            default : Date.now()
        }
    }
});
MovieSchema.statics = {
    fetch : function(cb) {
        return this.find({}).exec(cb);
    },
    findById : function(id,cb) {
        return this.findOne({_id:id}).exec(cb);
    }
};
//每一次保存之前会调用这个方法;
MovieSchema.pre("save",function(next) {
    next();
});
//为mongodb定义了这个数据模型, 这个数据模型和当前的数据库绑定了;
var Movie = mongoose.model("Movie",MovieSchema);
module.exports =  Movie;